/* Copyright (c) 1994 by Oracle Corporation.  All Rights Reserved.
 *
 * mna.h - OMN Addressing
 *
 * DESCRIPTION
 * Related man pages are mna(3).
 *
 * REVISIONS
 * jolkin    08/17/94  Creation of Version 2.1
 * jolkin    04/20/94  Creation of Version 2.0
 */

#ifndef MNA_ORACLE
#define MNA_ORACLE

#ifndef SYSX_ORACLE
#include <sysx.h>
#endif
#ifndef MN_ORACLE
#include <mn.h>
#endif

EXTC_START

/* Constant declarations */
#define MNAMAXLEN           ((size_t) 32)

/* Media Net address */
/* DISABLE check_naming */
struct mna
{
  ub1 bits[8];
};
/* ENABLE check_naming */

/* Macros and routines */
#define mnaClear(a1)        ((void) memset(a1, 0, sizeof(mna)))

#ifndef lint
# define mnaCopy(a1, a2)     ((*(a1)) = (*(a2)))
# define mnaNetCopy(a1, a2)  \
  ((void) ((*(a1) = *(a2)), (a1)->bits[6] = (a1)->bits[7] = 0))
#else
# define mnaCopy(a1, a2)     CPSTRUCT(*(a1), *(a2))
# define mnaNetCopy(a1, a2)  \
  ((void) (CPSTRUCT(*(a1), *(a2)), (a1)->bits[6] = (a1)->bits[7] = 0))
#endif

#define mnaEq(a1, a2)       \
  !memcmp((CONST dvoid *) (a1)->bits, (CONST dvoid *) (a2)->bits, 8)
#define mnaNetEq(a1, a2)    \
  !memcmp((CONST dvoid *) (a1)->bits, (CONST dvoid *) (a2)->bits, 6)

void mnaSetPort(mna *addr, ub2 prtno);

sb4  mnAddr(mna *, const char *);
void mnAtos(mna *, char *, size_t);
sb4 mnDeathWatch(mna *addr, mnHandler handler, dvoid *usrp);
sb4 mnDeathIgnore(mna *addr, dvoid *usrp);

EXTC_END
#endif /* MNA_ORACLE */
