/* Copyright (c) 1994 by Oracle Corporation.  All Rights Reserved.
 *
 * mnerr.h - Error & Status Codes
 *
 * DESCRIPTION
 * Related man pages are mnError(3) and mn_intro(3).
 *
 * REVISIONS
 * jolkin    08/21/94  Creation of Version 2.1
 * jolkin    04/20/94  Creation of Version 2.0
 */

#ifndef MNERR_ORACLE
#define MNERR_ORACLE

#ifndef SYSX_ORACLE
#include <sysx.h>
#endif

EXTC_START

#define MNSTS_NORMAL       ((sb4) 0)        /* normal, successful completion */
#define MNSTS_UNKNOWN      ((sb4) -1)            /* initial semaphore status */
#define MNSTS_ABORTED      ((sb4) -2)          /* blocking operation aborted */
#define MNSTS_EOS          ((sb4) -3)               /* end-of-stream reached */
#define MNSTS_TERMINATE    ((sb4) -4)          /* the process was terminated */
#define MNERR_FAILURE      ((sb4) -1001)  /* system- or NIO-specific failure */
#define MNERR_OVERFLOW     ((sb4) -1002)                     /* NIO overflow */
#define MNERR_WOULDBLOCK   ((sb4) -1003)            /* operation would block */
#define MNERR_TIMEOUT      ((sb4) -1004)              /* operation timed out */
#define MNERR_OUTMEM       ((sb4) -1005)                    /* out of memory */
#define MNERR_BADPARAM     ((sb4) -1006)                    /* bad parameter */
#define MNERR_TRUNCATE     ((sb4) -1007)        /* packet would be truncated */
#define MNERR_BROKEN       ((sb4) -1008)                    /* stream broken */
#define MNERR_BADADDR      ((sb4) -1009)          /* bad destination address */
#define MNERR_BADPROTO     ((sb4) -1010)         /* bad destination protocol */
#define MNERR_ALREADY      ((sb4) -1011)                /* already connected */
#define MNERR_NOTCONN      ((sb4) -1012)          /* Media Net not connected */
#define MNERR_DISCONN      ((sb4) -1013)            /* forcibly disconnected */
#define MNERR_NOSUCHOPER   ((sb4) -1014)                /* no such operation */
#define MNERR_NOTFOUND     ((sb4) -1015)                        /* not found */
#define MNERR_DUPLICATE    ((sb4) -1016)               /* duplicate detected */
#define MNERR_CTXEXP       ((sb4) -1017)       /* space for context expected */
#define MNERR_NOTINIT      ((sb4) -1018)                  /* not initialized */

CONST char *mnError(sb4);
sb4 mnLastError(void);

EXTC_END
#endif /* MNERR_ORACLE */
