/* Copyright (c) 1994 by Oracle Corporation.  All Rights Reserved.
 *
 * mnr.h - OMN Remote Procedure Call Global Definitions
 *
 * DESCRIPTION
 * Related man pages are mnrpc_intro(3), mnrIdCmp(3) and mnrConfig(3).
 *
 * REVISIONS
 * jolkin    05/06/94  Creation
 */

#ifndef MNR_ORACLE
#define MNR_ORACLE

#ifndef SYSX_ORACLE
#include <sysx.h>
#endif
#ifndef MN_ORACLE
#include <mn.h>
#endif
#ifndef MNX_ORACLE
#include <mnx.h>
#endif

EXTC_START

/* RPC type declarations */
typedef struct mnrid mnrid;                                /* RPC identifier */

/* version number manipulation */
#define MNVERS(version, release)   \
  ((((ub4) (version)) << 16) | ((release) & 0xffff))
#define MNGETVERS(vers)            ((vers) >> 16)
#define MNGETRELS(vers)            ((vers) & 0xffff)

/* program identifier */
/* DISABLE check_naming */
struct mnrid
{
  ub1 id[8];                                   /* globally unique identifier */
  ub4 vers;                                               /* program version */
};
/* ENABLE check_naming */

/* RPC identifier comparison */
sb4 mnrIdCmp(const mnrid *, const mnrid *, boolean);

/* RPC identifier marshalling routine */
boolean mnrxId(mnx *, dvoid *);

/* RPC memory management */
void mnrConfig(mnAlloc, mnFree);

EXTC_END
#endif /* MNR_ORACLE */
