/* Copyright (c) 1994 by Oracle Corporation.  All Rights Reserved.
 *
 * mnrc.h - OMN Remote Procedure Call Client-Side Public Interface
 *
 * DESCRIPTION
 * Related man pages are mnrFindServer(3), mnrMakeHandle(3),
 * mnrFreeHandle(3), and mnrCall(3).
 *
 * REVISIONS
 * jolkin     08/21/94  Creation of Version 2.1
 * jolkin     05/05/94  Creation
 */

#ifndef MNRC_ORACLE
#define MNRC_ORACLE

#ifndef SYSX_ORACLE
#include <sysx.h>
#endif
#ifndef MN_ORACLE
#include <mn.h>
#endif
#ifndef MNR_ORACLE
#include <mnr.h>
#endif

EXTC_START

/* client-side RPC type definitions */
typedef struct mnrb mnrb;                                  /* binding handle */

/* binding handle routines */
mnrb *mnrFindServer(const char *, const mnrid *);
mnrb *mnrMakeHandle(const mna *);
void  mnrFreeHandle(mnrb *);
void  mnrGetServerAddr(mnrb *, mna *);

/* RPC call routines */
sb4   mnrCall(mnrb *, dvoid **, const char *,
	      mnbv *, ub4, mnbv **, ub4 *, mnHandler, dvoid *);

EXTC_END
#endif /* MNRC_ORACLE */
