/* Copyright (c) 1994 by Oracle Corporation.  All Rights Reserved.
 *
 * mnsem.h - OMN Semaphore Management
 *
 * DESCRIPTION
 * Related man pages are mnsem(3) and mnSet(3).
 *
 * REVISIONS
 * jolkin    08/18/94  Creation of Version 2.1
 * jolkin    04/20/94  Creation of Version 2.0
 */

#ifndef MNSEM_ORACLE
#define MNSEM_ORACLE

#ifndef SYSX_ORACLE
#include <sysx.h>
#endif

EXTC_START

/* Asynchronous operation type definitions */
typedef struct mnsem mnsem;                                     /* semaphore */

/* Semaphore manipulation routines */
mnsem *mnSemAlloc(dvoid *);
void   mnSemFree(mnsem *);
void   mnSemSetUsrp(mnsem *, dvoid *);
dvoid *mnSemGetUsrp(mnsem *);
sb4    mnSemTest(mnsem *);
sb4    mnSemGroupTest(ub4, mnsem **);
sb4    mnSemWait(mnsem *);
sb4    mnSemOrW(ub4, ub4, mnsem **);
sb4    mnSemAndW(ub4, ub4, mnsem **);
void   mnSet(mnsem *, sb4);

EXTC_END
#endif /* MNSEM_ORACLE */
