rem Get SQL*Net user trace events for a database session
rem
rem Prompts for session index, serial number and collection name if variables 
rem s_idx, s_sn and cllctn have not been defined.
rem
rem Involves join of Server and SQL*Net data over cross-facility item 3.
rem Assumes Server and SQL*Net data were in the same collection.

select function_id, probe_id
from v_192216243_f_115_e_1_v2_3 u, epc_collection c
where c.collection_name = '&&cllctn' and
      c.collection_id = u.collection_number and
      u.cross_fac_3 = (select distinct t.cross_fac_3_start 
		       from v_192216243_f_5_e_11_7_3 t
		       where t.session_index_start = &&s_idx and
			     t.session_serial_start = &&s_sn and
			     t.collection_number = u.collection_number);
